function p = read_binary_parms_liq(filename,precision)

    switch precision
        case 'single'
            fprintf('Single precision specified.\n');
        case 'double'
            fprintf('Double precision specified.\n');
        otherwise
            error('Expecting single or double precision.\n');
    end
    
    try
    
        fileID = fopen(filename);

        p.rra = fread(fileID,1,precision);
        p.beta = fread(fileID,1,precision);
        
        p.clb = fread(fileID,1,precision);
        p.ggq_mDval = fread(fileID,1,precision);
        p.ggq_mlb = fread(fileID,1,precision);
        p.ggq_mub = fread(fileID,1,precision);
        p.ggq_mmean = fread(fileID,1,precision);
        p.ggq_mstd = fread(fileID,1,precision);
        p.ggq_mmass = fread(fileID,1,precision);
        p.errtol_bisect = fread(fileID,1,precision);
        p.maxiters_bisect = fread(fileID,1,'int');
        
        p.rH = fread(fileID,1,precision);
        p.rL = fread(fileID,1,precision);
        p.holding_cost = fread(fileID,1,precision);
        
        p.prob_liqshock = fread(fileID,1,precision);
        p.prob_meet_mkt_maker_ND = fread(fileID,1,precision);
        p.prob_meet_mkt_maker_D = fread(fileID,1,precision);
        p.bargain_power_mkt_maker_ND = fread(fileID,1,precision);
        p.bargain_power_mkt_maker_D = fread(fileID,1,precision);
        p.reenterprob = fread(fileID,1,precision);
        p.debt_z = fread(fileID,1,precision);
        p.debt_m = fread(fileID,1,precision);
        p.debt_writedown_reentry = fread(fileID,1,precision);
        p.max_def_prob = fread(fileID,1,precision);
        p.recovery_bmax = fread(fileID,1,precision);
        % p.issuance_cost = fread(fileID,1,precision);
        % p.cost_qviolation = fread(fileID,1,precision);
        % p.max_debt_buyback = fread(fileID,1,precision);
        
        p.gridsize_tfp = fread(fileID,1,'int');
        p.gridsize_b = fread(fileID,1,'int');
        p.bmax = fread(fileID,1,precision);
        
        p.rho_tfp = fread(fileID,1,precision);
        p.sigma_tfp = fread(fileID,1,precision);
        p.d_y = fread(fileID,1,precision);
        p.d_yy = fread(fileID,1,precision);
        p.d_b = fread(fileID,1,precision);
        p.d_bb = fread(fileID,1,precision);
        p.d_yb = fread(fileID,1,precision);
        
        p.grid_y_nd = fread(fileID,p.gridsize_tfp,precision);
        p.grid_y_d = fread(fileID,p.gridsize_tfp*p.gridsize_b,precision);
        p.grid_y_d = permute(reshape(p.grid_y_d,[p.gridsize_b p.gridsize_tfp]),[2 1]);
        p.grid_b = fread(fileID,p.gridsize_b,precision);
        p.prob_y = fread(fileID,p.gridsize_tfp*p.gridsize_tfp,precision);
        p.prob_y = permute(reshape(p.prob_y,[p.gridsize_tfp p.gridsize_tfp]),[2 1]);
        p.grid_uD_yb = fread(fileID,p.gridsize_tfp*p.gridsize_b,precision);
        p.grid_uD_yb = permute(reshape(p.grid_uD_yb,[p.gridsize_b p.gridsize_tfp]),[2 1]);
        
        p.maxiters = fread(fileID,1,'int');
        p.errtolV = fread(fileID,1,precision);
        p.errtolQ = fread(fileID,1,precision);
        p.NumUpdateRegimes = fread(fileID,1,'int');
        p.UpdateRegimeIter = fread(fileID,p.NumUpdateRegimes-1,'int');
        p.UpdateWeightOldV = fread(fileID,p.NumUpdateRegimes,precision);
        p.UpdateWeightOldQ = fread(fileID,p.NumUpdateRegimes,precision);
        p.UpdateWeightOldDefProb = fread(fileID,p.NumUpdateRegimes,precision);
        
        p.iters = fread(fileID,1,'int');
        p.errCVD = fread(fileID,1,precision);
        p.errCVND = fread(fileID,1,precision);
        p.errQHND = fread(fileID,1,precision);
        p.errQLND = fread(fileID,1,precision);
        p.errQHD = fread(fileID,1,precision);
        p.errQLD = fread(fileID,1,precision);

        fclose(fileID);
    
    catch
        fclose(fileID);
        error('Encountered error reading binary parameters file.\n');
    end

end