function [model_mat, model_no_liq_mat, p_no_liq] = CalcDecomposition_2term(p,model,useDevice,DisplayInterval)
% p and model comes from mexSolveModelGivenParms
% the output model is assumed to be converted to matlab's format using 
% conv_outputs = ConvertCPPtoMAT(p,model_outputs)

    % problem without liquidity concerns
    if p.rH~=p.rL; error('rH~=rL detected.'); end

    p_no_liq = p;
    p_no_liq.holding_cost = 0;

    model_no_liq = mexSolveModelGivenParms(p_no_liq, useDevice, DisplayInterval);
    
    % compute policies in matlab
    model_mat = ProcessMexGPUOutputs_liq(p, model);
    model_no_liq_temp = ConvertCPPtoMAT(p_no_liq,model_no_liq);
    model_no_liq_mat = ProcessMexGPUOutputs_liq(p_no_liq, model_no_liq_temp);

end