function stats_final = SimModelStats(p,model,NumPaths,T,TBurn,QuarterLength,NumQuartersExcludeAfterReentry)

    p.cumul_prob_y = cumsum(p.prob_y')';
    [V,D] = eig(p.prob_y');
    [~,idx] = min(abs(diag(D)-1));
    stat_prob_y = V(:,idx)/sum(V(:,idx));
    p.cumul_stat_prob_y = cumsum(stat_prob_y);
    
    rng(0); % reset random seed.
    Us_z = rand(T,NumPaths);
    Us_m = rand(T,NumPaths);
    Us_reenter = rand(T,NumPaths);
    
    % sims = cell(NumPaths);
    stats = cell(NumPaths,1);
    
    parfor i = 1:NumPaths
    % for i = 1:NumPaths
        % sims{i} = SimSinglePath(p,model,T,TBurn,Us_z(:,i),Us_m(:,i),Us_reenter(:,i));
        [~,stats{i}] = SimSinglePath(p,model,T,TBurn,...
            Us_z(:,i),Us_m(:,i),Us_reenter(:,i),QuarterLength,NumQuartersExcludeAfterReentry);
    end
    
    % process stats
    fldnames = fieldnames(stats{1});
    stats_final = struct;
    
    for i = 1:numel(fldnames)
        tempval = nanmean(cellfun(@(X)getfield(X,fldnames{i}),stats));
        stats_final = setfield(stats_final,fldnames{i},tempval);
    end

end