set(0,'DefaultFigureWindowStyle','docked')
clear all

% load('baseline_11042020.mat','p','model')
% load('baseline_11042020_ver2.mat','p','model')

LineWidth = 3;
FontSize = 25;

%% plot baseline

load('baseline_11042020.mat','p','model')

m0 = p.ggq_mmean;
y0 = 1;

[~,idx_y0] = min(abs(y0 - p.grid_y_nd));

ellND_base = NaN*zeros(p.gridsize_b,1);
defprob_base = NaN*zeros(p.gridsize_b,1);
recovery_base = NaN*zeros(p.gridsize_b,1);

for idx_b0 = 1:p.gridsize_b
    if m0>=model.defthresh(idx_y0,idx_b0)
        idx = find(model.policy{idx_y0,idx_b0}.eps_mesh(1:end-1)<=m0 & ...
            m0<=model.policy{idx_y0,idx_b0}.eps_mesh(2:end),1,'first');
        idx_bchoice = model.policy{idx_y0,idx_b0}.idx_bnext(idx);
        ellND_base(idx_b0) = model.ellND(idx_y0,idx_bchoice);
        defprob_base(idx_b0) = model.defprob(idx_y0,idx_bchoice);
        recovery_base(idx_b0) = min(p.recovery_bmax,p.grid_b(idx_b0))/p.grid_b(idx_b0);
    end
end

%% short term debt

% load('sensitivity analysis\sensitivity_one_period_debt.mat','p','model')
load('sensitivity analysis\sensitivity_one_year_debt.mat','p','model')

ellND_m1 = NaN*zeros(p.gridsize_b,1);
defprob_m1 = NaN*zeros(p.gridsize_b,1);
recovery_m1 = NaN*zeros(p.gridsize_b,1);

for idx_b0 = 1:p.gridsize_b
    if m0>=model.defthresh(idx_y0,idx_b0)
        idx = find(model.policy{idx_y0,idx_b0}.eps_mesh(1:end-1)<=m0 & ...
            m0<=model.policy{idx_y0,idx_b0}.eps_mesh(2:end),1,'first');
        idx_bchoice = model.policy{idx_y0,idx_b0}.idx_bnext(idx);
        ellND_m1(idx_b0) = model.ellND(idx_y0,idx_bchoice);
        defprob_m1(idx_b0) = model.defprob(idx_y0,idx_bchoice);
        recovery_m1(idx_b0) = min(p.recovery_bmax,p.grid_b(idx_b0))/p.grid_b(idx_b0);
    end
end

%% no recovery

load('sensitivity analysis\sensitivity_no_recovery.mat','p','model')

ellND_no_rec = NaN*zeros(p.gridsize_b,1);
defprob_no_rec = NaN*zeros(p.gridsize_b,1);
recovery_no_rec = NaN*zeros(p.gridsize_b,1);

for idx_b0 = 1:p.gridsize_b
    if m0>=model.defthresh(idx_y0,idx_b0)
        idx = find(model.policy{idx_y0,idx_b0}.eps_mesh(1:end-1)<=m0 & ...
            m0<=model.policy{idx_y0,idx_b0}.eps_mesh(2:end),1,'first');
        idx_bchoice = model.policy{idx_y0,idx_b0}.idx_bnext(idx);
        ellND_no_rec(idx_b0) = model.ellND(idx_y0,idx_bchoice);
        defprob_no_rec(idx_b0) = model.defprob(idx_y0,idx_bchoice);
        recovery_no_rec(idx_b0) = min(p.recovery_bmax,p.grid_b(idx_b0))/p.grid_b(idx_b0);
    end
end

%% plot

figure

subplot(1,2,1)
hold on
plot(defprob_base,(1+ellND_base).^12 - 1,'-b','LineWidth',LineWidth)
plot(defprob_m1,(1+ellND_m1).^12 - 1,'-.r','LineWidth',LineWidth)
plot(defprob_no_rec,(1+ellND_no_rec).^12 - 1,':k','LineWidth',LineWidth)
title('Default probability vs. liquidity premium','Interpreter','Latex','FontSize',FontSize)
xlabel('Default probability','Interpreter','Latex','FontSize',FontSize)
ylabel('$\ell_{ND}$, annualized','Interpreter','Latex','FontSize',FontSize)
set(gca,'xlim',[0.001 0.3])
% axis square
legend({'Long-term debt + recovery','Short-term debt','No recovery'},'Interpreter','Latex','FontSize',FontSize,'Location','NorthWest')
legend boxoff
axis square

subplot(1,2,2)
hold on
plot(defprob_base,recovery_base,'-b','LineWidth',LineWidth)
plot(defprob_m1,recovery_m1,'-.r','LineWidth',LineWidth)
plot(defprob_no_rec,recovery_no_rec,':k','LineWidth',LineWidth)
title('Default probability vs. recovery','Interpreter','Latex','FontSize',FontSize)
xlabel('Default probability','Interpreter','Latex','FontSize',FontSize)
ylabel('Recovery conditional on default','Interpreter','Latex','FontSize',FontSize)
set(gca,'xlim',[0.001 0.3])
% axis square
legend({'Long-term debt + recovery','Short-term debt','No recovery'},'Interpreter','Latex','FontSize',FontSize,'Location','NorthWest')
legend boxoff
axis square