function [qND_H,qND_L,qD_H,qD_L,qS_ND,qS_D] = CalcBondPrices_LongRun_LCP(p,pdef)

    B = zeros(6,1);
    A = zeros(6,6);
    
    B(1) = (1-pdef)*(p.m + (1-p.m)*p.z)/(1 + p.r);
    B(2) = (1-pdef)*(p.m + (1-p.m)*p.z)/(1 + p.r) - p.hc/(1 + p.r);
    B(4) = - (1-p.theta)*p.hc/(1 + p.r);
    
    A(1,1) = (1 - pdef)*(1 - p.m)*(1 - p.zeta)/(1 + p.r);
    A(1,2) = (1 - pdef)*(1 - p.m)*p.zeta/(1 + p.r);
    A(1,3) = pdef*(1 - p.zeta)/(1 + p.r);
    A(1,4) = pdef*p.zeta/(1 + p.r);
    
    A(2,2) = (1 - pdef)*(1 - p.m)*(1 - p.lambda)/(1 + p.r);
    A(2,4) = pdef*(1 - p.lambda)/(1 + p.r);
    A(2,5) = (1 - pdef)*(1 - p.m)*p.lambda/(1 + p.r);
    A(2,6) = pdef*p.lambda/(1 + p.r);
    
    A(3,1) = p.theta*p.f;
    A(3,3) = (1 - p.theta)*(1 - p.zeta)/(1 + p.r);
    A(3,4) = (1 - p.theta)*p.zeta/(1 + p.r);
    
    A(4,2) = p.theta*p.f;
    A(4,4) = (1 - p.theta)*(1 - p.lambda)/(1 + p.r);
    A(4,6) = (1 - p.theta)*p.lambda/(1 + p.r);
    
    A(5,1) = p.alphaND;
    A(5,2) = 1 - p.alphaND;
    
    A(6,3) = p.alphaD;
    A(6,4) = 1 - p.alphaD;
    
    q = LCP(eye(6,6) - A,-B);
    
    qND_H = q(1);
    qND_L = q(2);
    qD_H = q(3);
    qD_L = q(4);
    qS_ND = q(5);
    qS_D = q(6);
    
    % check 
    errs = zeros(6,1);
    
    
    errs(1) = ((1-pdef)*(p.m + (1-p.m)*(p.z + p.zeta*qND_L + (1-p.zeta)*qND_H)) ...
        + pdef*(p.zeta*qD_L + (1-p.zeta)*qD_H))/(1 + p.r) - qND_H;

    errs(2) = max(0,((1-pdef)*(p.m - p.hc + (1-p.m)*(p.z + p.lambda*qS_ND + (1-p.lambda)*qND_L)) ...
        + pdef*(-p.hc + p.lambda*qS_D + (1-p.lambda)*qD_L))/(1 + p.r)) - qND_L;

    errs(3) = (1-p.theta)*(p.zeta*qD_L + (1-p.zeta)*qD_H)/(1 + p.r) + p.theta*p.f*qND_H - qD_H;
    errs(4) = max(0,(1-p.theta)*(-p.hc + p.lambda*qS_D + (1-p.lambda)*qD_L)/(1 + p.r) + p.theta*p.f*qND_L) - qD_L;

    errs(5) = p.alphaND*qND_H + (1-p.alphaND)*qND_L - qS_ND;
    errs(6) = p.alphaD*qD_H + (1-p.alphaD)*qD_L - qS_D;
    
    
    check = max(abs(errs));
    
    if check>1e-3
        warning('Check CalcBondPrices_LongRun_LCP'); 
    end

end