addpath(genpath('../matlab'))
addpath('../src_mex')
clear all

%% parameters

load('../fit_parms.10302020.turnover_98_04/fit_parms_10302020_turnover_1998_2004_run2.mat',...
    'p','FittedParms');

p.beta = FittedParms.beta;
p.d_y = FittedParms.d_y;
p.d_yy = FittedParms.d_yy;
p.recovery_bmax = FittedParms.recovery_bmax;
p.holding_cost = 0; % FittedParms.holding_cost;

p_no_liq = p;
clear p

%% solve model on GPU

useDevice = 1;
DisplayInterval = 100;

tic
model_no_liq_gpu = mexSolveModelGivenParms(p_no_liq, useDevice, DisplayInterval);
toc

%% get policies on CPU

tic
model_no_liq_gpu_converted = ConvertCPPtoMAT(p_no_liq,model_no_liq_gpu);
[model_no_liq,p_no_liq] = ProcessMexGPUOutputs_liq(p_no_liq, model_no_liq_gpu_converted);
toc

%% simulate

TBurn = 12*10^3;
T = TBurn + 12*10^6;
QuarterLength = 3;
NumQuartersExcludeAfterReentry = 20;

rng(0);
Us_z = rand(T,1);
Us_m = rand(T,1);
Us_reenter = rand(T,1);

tic
[~,stats_no_liq] = SimSinglePath(p_no_liq,model_no_liq,T,TBurn,Us_z,Us_m,Us_reenter,QuarterLength,NumQuartersExcludeAfterReentry);
toc

%% save

save('baseline_no_liq_11042020.mat','p_no_liq','model_no_liq_gpu','model_no_liq_gpu_converted','model_no_liq','stats_no_liq')