clear all

%% load files

moments = {'DebtToOutput_mean','RecoveryFraction_mean','Spread_mean','Spread_std','SpreadLIQshare_mean',...
    'bidask_ND_mean','bidask_D_mean','TurnOver_mean','DefFreq'};

D = dir(pwd);

filenames = [];
idx_count = 0;

for i = 1:numel(D)
    if ~D(i).isdir && numel(D(i).name)>3
        if strcmpi(D(i).name(end-3:end),'.mat')
            idx_count = idx_count + 1;
            filenames{idx_count} = D(i).name;
        end
    end
end

num_moments = numel(moments);
moment_vals = NaN*zeros(1+numel(filenames),num_moments);

for i = 1:(1+numel(filenames))
    
    if i==1
        % baseline
        load('../baseline_11042020.mat','p','stats');
    else
        load(filenames{i-1},'p','stats');
    end
    
    for j = 1:num_moments
        if strcmpi('TurnOver_mean',moments{j})
            moment_vals(i,j) = 12*getfield(stats,moments{j});
        elseif strcmpi('SpreadLIQshare_mean',moments{j})
            moment_vals(i,j) = getfield(stats,'SpreadLIQ_mean')/getfield(stats,'Spread_mean'); % mean over mean
        else
            moment_vals(i,j) = getfield(stats,moments{j});
        end
    end 
    
    clear p stats
        
end

%% output

fprintf('\nFile name &');
for i = 1:num_moments
    if i<num_moments
        fprintf(' %s &', moments{i})
    else
        fprintf(' %s \\\\', moments{i})
    end
end

for i = 1:(1+numel(filenames))
    if i==1
        fprintf('\n%s &', 'baseline')
    else
        fprintf('\n%s &', filenames{i-1})
    end
    for j = 1:num_moments
        if j<num_moments
            fprintf(' %6.4f &', moment_vals(i,j))
        else
            fprintf(' %6.4f \\\\', moment_vals(i,j))
        end
    end
end

fprintf('\n')