clear all

%% files

filenames = {'../baseline_no_liq_11042020.mat','welfare_holdcost1.mat',...
    'welfare_holdcost2.mat','../baseline_11042020.mat'};
% code computes V = u(c) + beta*V'

%% compute welfare

N = numel(filenames);
CEcons = zeros(N,1);
hc_vals = zeros(N,1);

load(filenames{1});
p = p_no_liq;
model = model_no_liq;
model.prob_y = model_no_liq_gpu_converted.prob_y;
CEcons(1) = ComputeWelfare(p,model);
hc_vals(1) = p.holding_cost;

for i = 2:N
    
    load(filenames{i});
    model.prob_y = model_gpu_converted.prob_y;
    CEcons(i)= ComputeWelfare(p,model);
    hc_vals(i) = p.holding_cost;
    
end

save('welfare.mat','CEcons','hc_vals')