#ifndef LIQUIDITY_IO_H
#define LIQUIDITY_IO_H

#include <cstring>
#include "liquidity_defs.h"
#include "realtype.h"

std::string CreateNewFolder(const char *save_folder_name);
void write_parms_to_file(parms_bsl_mod &p, const char* filename, int iters,
	REAL_TYPE err_CVD, REAL_TYPE err_CVND, REAL_TYPE err_qH_ND, REAL_TYPE err_qL_ND, REAL_TYPE err_qH_D, REAL_TYPE err_qL_D);
template <typename T> void write_2d_to_file(int dim1, int dim2, T *h_x, const char *filename);
template <typename T> void read_2d_from_file(int &dim1, int &dim2, T *h_x, const char *filename);
std::string save_outputs(const char *save_folder_name, parms_bsl_mod &p, REAL_TYPE *CVDs, REAL_TYPE *CVNDs, REAL_TYPE *qH_NDs,
	REAL_TYPE *qL_NDs, REAL_TYPE *qH_Ds, REAL_TYPE *qL_Ds, int iters,
	REAL_TYPE err_CVD, REAL_TYPE err_CVND, REAL_TYPE err_qH_ND, REAL_TYPE err_qL_ND, REAL_TYPE err_qH_D, REAL_TYPE err_qL_D);
std::string save_outputs_detailed(const char *save_folder_name, parms_bsl_mod &p, REAL_TYPE *CVDs, REAL_TYPE *CVNDs, REAL_TYPE *qH_NDs,
	REAL_TYPE *qL_NDs, REAL_TYPE *qH_Ds, REAL_TYPE *qL_Ds, int iters, 
	REAL_TYPE err_CVD, REAL_TYPE err_CVND, REAL_TYPE err_qH_ND, REAL_TYPE err_qL_ND, REAL_TYPE err_qH_D, REAL_TYPE err_qL_D,
	REAL_TYPE *CVDs_old, REAL_TYPE *CVNDs_old, REAL_TYPE *qH_NDs_old,
	REAL_TYPE *qL_NDs_old, REAL_TYPE *qH_Ds_old, REAL_TYPE *qL_Ds_old, REAL_TYPE *defprob, REAL_TYPE *defprob_old, REAL_TYPE *defthresh);
//void read_inputs(const char *input_folder_name, REAL_TYPE *CVDs, REAL_TYPE *CVNDs, REAL_TYPE *qH_NDs,
//	REAL_TYPE *qL_NDs, REAL_TYPE *qH_Ds, REAL_TYPE *qL_Ds);

#endif // !LIQUIDITY_IO_H
