#include "realtype.h"
#include "liquidity_defs.h"
#include "liquidity_vfi.h"
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <cstring>
#include <sstream>

/*
Implementation: use openmp to loop over files. Note: this will depend on how many gpus there are.
*/

int main(int argc, char* argv[])
{

	printf("program format: ./main [inputfilename] [outputfoldername] [useDevice (optional, default=0)]\n");
	printf("example: ./main parms.txt output 0\n");

	char *inputfilename;
	char *outputfoldername;
	int useDevice;

	inputfilename = argv[1];
	printf("inputfilename: %s\n", inputfilename);
	outputfoldername = argv[2];
	printf("outputfoldername: %s\n", outputfoldername);
	useDevice = atoi(argv[3]);
	printf("useDevice: %d\n", useDevice);	

	parms_bsl_mod p;

	if (p.readparms(inputfilename) == EXIT_SUCCESS)
	{
		// solve model and save
		SolveModel(p, outputfoldername, useDevice);
		// delete p
		p.clean();
	}

	return(EXIT_SUCCESS);

}